<?php

class actionUsersProfileEditEmail extends cmsAction {

    public function run($profile, $do=false){

        // проверяем наличие доступа
        if ($profile['id'] != $this->cms_user->id && !$this->cms_user->is_admin) { cmsCore::error404(); }

        $form = $do != 'confirm' ? $this->getForm('email') : $this->getForm('confirm_email');

        $is_submitted = $this->request->has('submit');

        $data = array();

        if ($is_submitted){

            $data = $form->parse($this->request, $is_submitted);

            $errors = $form->validate($this,  $data);

            if($data['old_email'] != $profile['email'] && !$do) $errors['old_email'] = 'Текущий Email указан не верно';

            if (!$errors){

                if(isset($data['email']) && !$do){

                	cmsUser::addSessionMessage('На новый Email отправлен проверочный код. Введите его для подтверждения.');

                	$code = md5($profile['email'] . $data['email'] . microtime());

                	cmsUser::sessionSet('confirm_email', $code);
                	cmsUser::sessionSet('to_email', $data['email']);

                	$messenger = cmsCore::getController('messages');
                    $to = array('email' => $data['email'], 'name' => $profile['nickname']);
                    $letter = array('name' => 'email_update');

                    $messenger->sendEmail($to, $letter, array(
                        'nickname' => $profile['nickname'],
                        'code' => $code
                    ));

                	$this->redirectToAction($profile['id'], array('edit', 'email', 'confirm'));

                } elseif(isset($data['code']) && $do == 'confirm') {

                	$code = cmsUser::sessionGet('confirm_email', 'true');
                	$email = cmsUser::sessionGet('to_email', 'true');

                	if($data['code'] == $code && isset($email)) {

                		$result = $this->model->updateUser($profile['id'], array('email' => $email));

                		if(!$result['errors']) {

                			cmsUser::addSessionMessage('Email успешно изменен', 'success');

                			$this->redirectToAction($profile['id']);

                		} else {

                			cmsUser::addSessionMessage('Ошибка! Для продолжения необходимо запросить новый код.', 'error');

                			$this->redirectToAction($profile['id'], array('edit', 'email'));

                		}

                	} else {

						cmsUser::addSessionMessage('Вы не верно указали проверочный код. Для продолжения необходимо запросить новый код.', 'error');

                		$this->redirectToAction($profile['id'], array('edit', 'email'));

                	}

                }

            }

            if ($errors){
                cmsUser::addSessionMessage(LANG_FORM_ERRORS, 'error');
            }

        }

        return $this->cms_template->render('profile_edit_email', array(
            'id'      => $profile['id'],
            'profile' => $profile,
            'data'    => $data,
            'form'    => $form,
            'errors'  => isset($errors) ? $errors : false,
            'do' => $do
        ));

    }

}
